
#ifndef HELPERS_H
	#define HELPERS_H
	#include <system.h>
	#include <string.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include <memory.h>
	#include <rand.h>
	#include <ctype.h>
	#include <rand.h>
	#include "stackdefs.h"
	
	DWORD GenerateRandomDWORD(); //generates a random DWORD (unsigned long)
	WORD  GenerateRandomWORD(); //generates a random WORD (unsigned int)
	BOOL StringToIPAddress(BYTE* str, IP_ADDR* IPAddress); //converts a string to I_ADDR type
	void uitoa(WORD Value, BYTE* Buffer); //converts unsigned int to string
	void ultoa(DWORD Value, BYTE* Buffer); //converts a long to string
	unsigned int swaps(unsigned int val); //swaps low & high byte in a short
	DWORD swapl(DWORD v); //swaps low & high short in a DWORD
	char* strupr(char* s); //upper case string conversion
	//DWORD leftRotateDWORD(DWORD val, BYTE bits); //rotates a DWORD over bits
	void FormatNetBIOSName(BYTE Name[]); //format comp. name (16 chars, last char=0x00 spaces added if needed)
	unsigned char * strnchr(const unsigned char *searchString, unsigned int count, char c); //search for characters in a string
	unsigned int createshort(unsigned char low, unsigned char high); //creates a short of low & high byte (inline func)
	//void memcpy(unsigned char * dst, unsigned char * src, unsigned int len); //we use the boostc equivalent which automatically adapts to the max size of an array
	unsigned char LOW(unsigned int val); //return low byte
	unsigned char HIGH(unsigned int val); //return high byte
	unsigned char swapb(unsigned char val); //swap the low nibble and high nibble of a byte

	//macros for getting the high/low nibble from a byte					
	#define LOWNIBBLE(x) ((x) & 0x0F)
	#define HIGHNIBBLE(x) ((x) & 0xF0)
	
	//returns low byte
	inline char LOW(unsigned int val){
		return ((WORD_VAL)val).v[0];
	}

	inline unsigned char HIGH(unsigned int val){
		return ((WORD_VAL)val).v[1];
	}
	
	inline WORD GenerateRandomWORD(void){
		return rand();
	}
#endif