#ifndef _SPI_H_

	#define _SPI_H_
	
	#include <system.h>
	#include <string.h>
	#include <stdio.h>
	#include <stdlib.h>
	#include "config.h"
	
	
	void spi_init();
	void spi_transmit(unsigned char byte);
	void spi_transmit_array(unsigned char * bytes, unsigned int count);
	void spi_transmit_string(unsigned char * string);
	unsigned char spi_read();
	unsigned int spi_read_array(unsigned char * bytes, unsigned int count);

#endif